LeetCode 题解1:Two Sum

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9 Output: index1=1, index2=2

解法

  1. 暴力破解,时间复杂度O(N*2)。
  2. 使用HashMap,以空间换时间,在遍历的同时记录信息

代码如下

public int[] twoSum(int[] nums, int target) {
    
    int[] result = new int[2];
	
	HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
	
	for ( int i = 0; i < nums.length; i++ ) {
		
		Integer another_number = map.get( target - nums[i] );
		if (another_number != null) {
			result[0] = another_number + 1;
			result[1] = i + 1;
			return result;
		}
		
		else 
			map.put(nums[i], i);
	}
	
	return null;
}
Written on December 27, 2015